"use strict";var Buffer=require("safe-buffer").Buffer,createHash=require("create-hash"),BN=require("bn.js"),EC=require("elliptic").ec,messages=require("../messages.json"),ec=new EC("secp256k1"),ecparams=ec.curve;function loadCompressedPublicKey(e,r){var n=new BN(r);if(0<=n.cmp(ecparams.p))return null;var s=(n=n.toRed(ecparams.red)).redSqr().redIMul(n).redIAdd(ecparams.b).redSqrt();return 3===e!==s.isOdd()&&(s=s.redNeg()),ec.keyPair({pub:{x:n,y:s}})}function loadUncompressedPublicKey(e,r,n){var s=new BN(r),a=new BN(n);if(0<=s.cmp(ecparams.p)||0<=a.cmp(ecparams.p))return null;if(s=s.toRed(ecparams.red),a=a.toRed(ecparams.red),(6===e||7===e)&&a.isOdd()!==(7===e))return null;var o=s.redSqr().redIMul(s);return a.redSqr().redISub(o.redIAdd(ecparams.b)).isZero()?ec.keyPair({pub:{x:s,y:a}}):null}function loadPublicKey(e){var r=e[0];switch(r){case 2:case 3:return 33!==e.length?null:loadCompressedPublicKey(r,e.slice(1,33));case 4:case 6:case 7:return 65!==e.length?null:loadUncompressedPublicKey(r,e.slice(1,33),e.slice(33,65));default:return null}}exports.privateKeyVerify=function(e){var r=new BN(e);return r.cmp(ecparams.n)<0&&!r.isZero()},exports.privateKeyExport=function(e,r){var n=new BN(e);if(0<=n.cmp(ecparams.n)||n.isZero())throw new Error(messages.EC_PRIVATE_KEY_EXPORT_DER_FAIL);return Buffer.from(ec.keyFromPrivate(e).getPublic(r,!0))},exports.privateKeyNegate=function(e){var r=new BN(e);return r.isZero()?Buffer.alloc(32):ecparams.n.sub(r).umod(ecparams.n).toArrayLike(Buffer,"be",32)},exports.privateKeyModInverse=function(e){var r=new BN(e);if(0<=r.cmp(ecparams.n)||r.isZero())throw new Error(messages.EC_PRIVATE_KEY_RANGE_INVALID);return r.invm(ecparams.n).toArrayLike(Buffer,"be",32)},exports.privateKeyTweakAdd=function(e,r){var n=new BN(r);if(0<=n.cmp(ecparams.n))throw new Error(messages.EC_PRIVATE_KEY_TWEAK_ADD_FAIL);if(n.iadd(new BN(e)),0<=n.cmp(ecparams.n)&&n.isub(ecparams.n),n.isZero())throw new Error(messages.EC_PRIVATE_KEY_TWEAK_ADD_FAIL);return n.toArrayLike(Buffer,"be",32)},exports.privateKeyTweakMul=function(e,r){var n=new BN(r);if(0<=n.cmp(ecparams.n)||n.isZero())throw new Error(messages.EC_PRIVATE_KEY_TWEAK_MUL_FAIL);return n.imul(new BN(e)),n.cmp(ecparams.n)&&(n=n.umod(ecparams.n)),n.toArrayLike(Buffer,"be",32)},exports.publicKeyCreate=function(e,r){var n=new BN(e);if(0<=n.cmp(ecparams.n)||n.isZero())throw new Error(messages.EC_PUBLIC_KEY_CREATE_FAIL);return Buffer.from(ec.keyFromPrivate(e).getPublic(r,!0))},exports.publicKeyConvert=function(e,r){var n=loadPublicKey(e);if(null===n)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);return Buffer.from(n.getPublic(r,!0))},exports.publicKeyVerify=function(e){return null!==loadPublicKey(e)},exports.publicKeyTweakAdd=function(e,r,n){var s=loadPublicKey(e);if(null===s)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);if(0<=(r=new BN(r)).cmp(ecparams.n))throw new Error(messages.EC_PUBLIC_KEY_TWEAK_ADD_FAIL);var a=ecparams.g.mul(r).add(s.pub);if(a.isInfinity())throw new Error(messages.EC_PUBLIC_KEY_TWEAK_ADD_FAIL);return Buffer.from(a.encode(!0,n))},exports.publicKeyTweakMul=function(e,r,n){var s=loadPublicKey(e);if(null===s)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);if(0<=(r=new BN(r)).cmp(ecparams.n)||r.isZero())throw new Error(messages.EC_PUBLIC_KEY_TWEAK_MUL_FAIL);return Buffer.from(s.pub.mul(r).encode(!0,n))},exports.publicKeyCombine=function(e,r){for(var n=new Array(e.length),s=0;s<e.length;++s)if(n[s]=loadPublicKey(e[s]),null===n[s])throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);for(var a=n[0].pub,o=1;o<n.length;++o)a=a.add(n[o].pub);if(a.isInfinity())throw new Error(messages.EC_PUBLIC_KEY_COMBINE_FAIL);return Buffer.from(a.encode(!0,r))},exports.signatureNormalize=function(e){var r=new BN(e.slice(0,32)),n=new BN(e.slice(32,64));if(0<=r.cmp(ecparams.n)||0<=n.cmp(ecparams.n))throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);var s=Buffer.from(e);return 1===n.cmp(ec.nh)&&ecparams.n.sub(n).toArrayLike(Buffer,"be",32).copy(s,32),s},exports.signatureExport=function(e){var r=e.slice(0,32),n=e.slice(32,64);if(0<=new BN(r).cmp(ecparams.n)||0<=new BN(n).cmp(ecparams.n))throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);return{r:r,s:n}},exports.signatureImport=function(e){var r=new BN(e.r);0<=r.cmp(ecparams.n)&&(r=new BN(0));var n=new BN(e.s);return 0<=n.cmp(ecparams.n)&&(n=new BN(0)),Buffer.concat([r.toArrayLike(Buffer,"be",32),n.toArrayLike(Buffer,"be",32)])},exports.sign=function(n,s,e,a){if("function"==typeof e){var o=e;e=function(e){var r=o(n,s,null,a,e);if(!Buffer.isBuffer(r)||32!==r.length)throw new Error(messages.ECDSA_SIGN_FAIL);return new BN(r)}}var r=new BN(s);if(0<=r.cmp(ecparams.n)||r.isZero())throw new Error(messages.ECDSA_SIGN_FAIL);var c=ec.sign(n,s,{canonical:!0,k:e,pers:a});return{signature:Buffer.concat([c.r.toArrayLike(Buffer,"be",32),c.s.toArrayLike(Buffer,"be",32)]),recovery:c.recoveryParam}},exports.verify=function(e,r,n){var s={r:r.slice(0,32),s:r.slice(32,64)},a=new BN(s.r),o=new BN(s.s);if(0<=a.cmp(ecparams.n)||0<=o.cmp(ecparams.n))throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);if(1===o.cmp(ec.nh)||a.isZero()||o.isZero())return!1;var c=loadPublicKey(n);if(null===c)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);return ec.verify(e,s,{x:c.pub.x,y:c.pub.y})},exports.recover=function(e,r,n,s){var a={r:r.slice(0,32),s:r.slice(32,64)},o=new BN(a.r),c=new BN(a.s);if(0<=o.cmp(ecparams.n)||0<=c.cmp(ecparams.n))throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);try{if(o.isZero()||c.isZero())throw new Error;var t=ec.recoverPubKey(e,a,n);return Buffer.from(t.encode(!0,s))}catch(e){throw new Error(messages.ECDSA_RECOVER_FAIL)}},exports.ecdh=function(e,r){var n=exports.ecdhUnsafe(e,r,!0);return createHash("sha256").update(n).digest()},exports.ecdhUnsafe=function(e,r,n){var s=loadPublicKey(e);if(null===s)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);var a=new BN(r);if(0<=a.cmp(ecparams.n)||a.isZero())throw new Error(messages.ECDH_FAIL);return Buffer.from(s.pub.mul(a).encode(!0,n))};