"use strict";var Buffer=require("safe-buffer").Buffer,createHash=require("create-hash"),HmacDRBG=require("drbg.js/hmac"),messages=require("../messages.json"),BN=require("./bn"),ECPoint=require("./ecpoint"),g=require("./ecpointg");exports.privateKeyVerify=function(r){var e=BN.fromBuffer(r);return!(e.isOverflow()||e.isZero())},exports.privateKeyExport=function(r,e){var f=BN.fromBuffer(r);if(f.isOverflow()||f.isZero())throw new Error(messages.EC_PRIVATE_KEY_EXPORT_DER_FAIL);return g.mul(f).toPublicKey(e)},exports.privateKeyNegate=function(r){var e=BN.fromBuffer(r);return e.isZero()?Buffer.alloc(32):(0<e.ucmp(BN.n)&&e.isub(BN.n),BN.n.sub(e).toBuffer())},exports.privateKeyModInverse=function(r){var e=BN.fromBuffer(r);if(e.isOverflow()||e.isZero())throw new Error(messages.EC_PRIVATE_KEY_RANGE_INVALID);return e.uinvm().toBuffer()},exports.privateKeyTweakAdd=function(r,e){var f=BN.fromBuffer(e);if(f.isOverflow())throw new Error(messages.EC_PRIVATE_KEY_TWEAK_ADD_FAIL);if(f.iadd(BN.fromBuffer(r)),f.isOverflow()&&f.isub(BN.n),f.isZero())throw new Error(messages.EC_PRIVATE_KEY_TWEAK_ADD_FAIL);return f.toBuffer()},exports.privateKeyTweakMul=function(r,e){var f=BN.fromBuffer(e);if(f.isOverflow()||f.isZero())throw new Error(messages.EC_PRIVATE_KEY_TWEAK_MUL_FAIL);var o=BN.fromBuffer(r);return f.umul(o).ureduce().toBuffer()},exports.publicKeyCreate=function(r,e){var f=BN.fromBuffer(r);if(f.isOverflow()||f.isZero())throw new Error(messages.EC_PUBLIC_KEY_CREATE_FAIL);return g.mul(f).toPublicKey(e)},exports.publicKeyConvert=function(r,e){var f=ECPoint.fromPublicKey(r);if(null===f)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);return f.toPublicKey(e)},exports.publicKeyVerify=function(r){return null!==ECPoint.fromPublicKey(r)},exports.publicKeyTweakAdd=function(r,e,f){var o=ECPoint.fromPublicKey(r);if(null===o)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);if((e=BN.fromBuffer(e)).isOverflow())throw new Error(messages.EC_PUBLIC_KEY_TWEAK_ADD_FAIL);var u=g.mul(e).add(o);if(u.inf)throw new Error(messages.EC_PUBLIC_KEY_TWEAK_ADD_FAIL);return u.toPublicKey(f)},exports.publicKeyTweakMul=function(r,e,f){var o=ECPoint.fromPublicKey(r);if(null===o)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);if((e=BN.fromBuffer(e)).isOverflow()||e.isZero())throw new Error(messages.EC_PUBLIC_KEY_TWEAK_MUL_FAIL);return o.mul(e).toPublicKey(f)},exports.publicKeyCombine=function(r,e){for(var f=new Array(r.length),o=0;o<r.length;++o)if(f[o]=ECPoint.fromPublicKey(r[o]),null===f[o])throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);for(var u=f[0],i=1;i<f.length;++i)u=u.add(f[i]);if(u.inf)throw new Error(messages.EC_PUBLIC_KEY_COMBINE_FAIL);return u.toPublicKey(e)},exports.signatureNormalize=function(r){var e=BN.fromBuffer(r.slice(0,32)),f=BN.fromBuffer(r.slice(32,64));if(e.isOverflow()||f.isOverflow())throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);var o=Buffer.from(r);return f.isHigh()&&BN.n.sub(f).toBuffer().copy(o,32),o},exports.signatureExport=function(r){var e=r.slice(0,32),f=r.slice(32,64);if(BN.fromBuffer(e).isOverflow()||BN.fromBuffer(f).isOverflow())throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);return{r:e,s:f}},exports.signatureImport=function(r){var e=BN.fromBuffer(r.r);e.isOverflow()&&(e=BN.fromNumber(0));var f=BN.fromBuffer(r.s);return f.isOverflow()&&(f=BN.fromNumber(0)),Buffer.concat([e.toBuffer(),f.toBuffer()])},exports.sign=function(r,e,f,o){var u=BN.fromBuffer(e);if(u.isOverflow()||u.isZero())throw new Error(messages.ECDSA_SIGN_FAIL);if(null===f){var i=new HmacDRBG("sha256",e,r,o);f=function(){return i.generate(32)}}for(var s=BN.fromBuffer(r),n=0;;++n){var t=f(r,e,null,o,n);if(!Buffer.isBuffer(t)||32!==t.length)throw new Error(messages.ECDSA_SIGN_FAIL);var a=BN.fromBuffer(t);if(!a.isOverflow()&&!a.isZero()){var E=g.mul(a),B=E.x.fireduce();if(!B.isZero()){var l=a.uinvm().umul(B.umul(u).ureduce().iadd(s).fireduce()).ureduce();if(!l.isZero()){var m=(0!==E.x.ucmp(B)?2:0)|(E.y.isOdd()?1:0);return l.isHigh()&&(l=BN.n.sub(l),m^=1),{signature:Buffer.concat([B.toBuffer(),l.toBuffer()]),recovery:m}}}}}},exports.verify=function(r,e,f){var o=BN.fromBuffer(e.slice(0,32)),u=BN.fromBuffer(e.slice(32,64));if(o.isOverflow()||u.isOverflow())throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);if(u.isHigh()||o.isZero()||u.isZero())return!1;var i=ECPoint.fromPublicKey(f);if(null===i)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);var s=u.uinvm(),n=s.umul(BN.fromBuffer(r)).ureduce(),t=s.umul(o).ureduce(),a=g.mulAdd(n,i,t);if(a.inf)return!1;var E=a.z.redSqr();return 0===o.redMul(E).ucmp(a.x)||!(0<=o.ucmp(BN.psn))&&0===o.iadd(BN.psn).redMul(E).ucmp(a.x)},exports.recover=function(r,e,f,o){var u=BN.fromBuffer(e.slice(0,32)),i=BN.fromBuffer(e.slice(32,64));if(u.isOverflow()||i.isOverflow())throw new Error(messages.ECDSA_SIGNATURE_PARSE_FAIL);do{if(u.isZero()||i.isZero())break;var s=u;if(f>>1){if(0<=s.ucmp(BN.psn))break;s=u.add(BN.n)}var n=Buffer.concat([Buffer.from([2+(1&f)]),s.toBuffer()]),t=ECPoint.fromPublicKey(n);if(null===t)break;var a=u.uinvm(),E=BN.n.sub(BN.fromBuffer(r)).umul(a).ureduce(),B=i.umul(a).ureduce();return ECPoint.fromECJPoint(g.mulAdd(E,t,B)).toPublicKey(o)}while(0);throw new Error(messages.ECDSA_RECOVER_FAIL)},exports.ecdh=function(r,e){var f=exports.ecdhUnsafe(r,e,!0);return createHash("sha256").update(f).digest()},exports.ecdhUnsafe=function(r,e,f){var o=ECPoint.fromPublicKey(r);if(null===o)throw new Error(messages.EC_PUBLIC_KEY_PARSE_FAIL);var u=BN.fromBuffer(e);if(u.isOverflow()||u.isZero())throw new Error(messages.ECDH_FAIL);return o.mul(u).toPublicKey(f)};