"use strict";var asn=require("asn1.js"),Buffer=require("safe-buffer").Buffer,lengths={prime256v1:Math.ceil(32),secp256k1:Math.ceil(32),secp384r1:Math.ceil(48),secp521r1:Math.ceil(521/8)},jwkCurves={prime256v1:"P-256",secp256k1:"P-256K",secp384r1:"P-384",secp521r1:"P-521"},curves={"P-256":"prime256v1","P-256K":"secp256k1","P-384":"secp384r1","P-521":"secp521r1"},ASN1ECRfc5915Key=asn.define("Rfc5915Key",function(){this.seq().obj(this.key("version").int(),this.key("privateKey").octstr(),this.key("parameters").optional().explicit(0).objid({"1 2 840 10045 3 1 7":"prime256v1","1 3 132 0 10":"secp256k1","1 3 132 0 34":"secp384r1","1 3 132 0 35":"secp521r1"}),this.key("publicKey").optional().explicit(1).bitstr())}),ASN1ECPkcs8Key=asn.define("Pkcs8Key",function(){this.seq().obj(this.key("version").int(),this.key("algorithmIdentifier").seq().obj(this.key("privateKeyType").objid({"1 2 840 10045 2 1":"EC"}),this.key("parameters").objid({"1 2 840 10045 3 1 7":"prime256v1","1 3 132 0 10":"secp256k1","1 3 132 0 34":"secp384r1","1 3 132 0 35":"secp521r1"})),this.key("privateKey").octstr())}),ASN1ECSpkiKey=asn.define("SpkiKey",function(){this.seq().obj(this.key("algorithmIdentifier").seq().obj(this.key("publicKeyType").objid({"1 2 840 10045 2 1":"EC"}),this.key("parameters").objid({"1 2 840 10045 3 1 7":"prime256v1","1 3 132 0 10":"secp256k1","1 3 132 0 34":"secp384r1","1 3 132 0 35":"secp521r1"})),this.key("publicKey").bitstr())});function parsePublicKeyBuffer(e,r){var t=lengths[e];if(4!=r[0])throw new TypeError("Compressed key unsupported");if(r.length!=2*t+1)throw new TypeError("Invalid uncompressed key size");return{c:e,x:r.slice(1,t+1),y:r.slice(t+1)}}function parsePkcs8(e){var r=ASN1ECPkcs8Key.decode(e,"der"),t=ASN1ECRfc5915Key.decode(r.privateKey,"der"),i=r.algorithmIdentifier.parameters,n=lengths[i],s=t.privateKey;if(s.length>n)throw new TypeError("Invalid private key size: expected "+n+" gotten "+s.length);var f=parsePublicKeyBuffer(i,t.publicKey.data);return f.d=s,f}function parseRfc5915(e){var r=ASN1ECRfc5915Key.decode(e,"der"),t=lengths[r.parameters],i=r.privateKey;if(i.length>t)throw new TypeError("Invalid private key size: expected "+t+" gotten "+i.length);var n=parsePublicKeyBuffer(r.parameters,r.publicKey.data);return n.d=i,n}function parseSpki(e){var r=ASN1ECSpkiKey.decode(e,"der");return parsePublicKeyBuffer(r.algorithmIdentifier.parameters,r.publicKey.data)}var pemRfc5915RE=/-+BEGIN EC PRIVATE KEY-+([\s\S]+)-+END EC PRIVATE KEY-+/m,pemPkcs8RE=/-+BEGIN PRIVATE KEY-+([\s\S]*)-+END PRIVATE KEY-+/m,pemSpkiRE=/-+BEGIN PUBLIC KEY-+([\s\S]*)-+END PUBLIC KEY-+/m;function parsePem(e){if("string"!=typeof e)throw new TypeError("PEM must be a string");var r=null;if(r=e.match(pemRfc5915RE))return parseRfc5915(new Buffer(r[1].replace(/[\s-]/gm,""),"base64"));if(r=e.match(pemPkcs8RE))return parsePkcs8(new Buffer(r[1].replace(/[\s-]/gm,""),"base64"));if(r=e.match(pemSpkiRE))return parseSpki(new Buffer(r[1].replace(/[\s-]/gm,""),"base64"));throw new TypeError("Unrecognized PEM key structure")}function isObject(e){return!!e&&e.constructor===Object}function ECKey(e,r){if(!(this instanceof ECKey))return new ECKey(e,r);var t,i,n,s;if(r||(r="pem"),Buffer.isBuffer(e))if("pem"==r)t=(f=parsePem(e.toString("ascii"))).c,n=f.x,s=f.y,i=f.d;else if("pkcs8"==r||"rfc5208"==r){t=(f=parsePkcs8(e)).c,n=f.x,s=f.y,i=f.d}else{if("spki"!=r&&"rfc5280"!=r)throw new TypeError('Unknown format for EC Key "'+r+'"');t=(f=parseSpki(e)).c,n=f.x,s=f.y,i=f.d}else if("string"==typeof e){if("pem"==r)t=(f=parsePem(e)).c,n=f.x,s=f.y,i=f.d;else if("pkcs8"==r||"rfc5208"==r){t=(f=parsePkcs8(new Buffer(e,"base64"))).c,n=f.x,s=f.y,i=f.d}else{if("spki"!=r&&"rfc5280"!=r)throw new TypeError('Unknown format for EC Key "'+r+'"');t=(f=parseSpki(new Buffer(e,"base64"))).c,n=f.x,s=f.y,i=f.d}}else{if(!isObject(e))throw new TypeError("Unrecognized format for EC key");if("string"==typeof e.curve?t=e.curve:"string"==typeof e.crv&&(t=curves[e.crv]||e.crv),Buffer.isBuffer(e.privateKey)?i=e.privateKey:"string"==typeof e.privateKey?i=new Buffer(e.privateKey,"base64"):Buffer.isBuffer(e.d)?i=e.d:"string"==typeof e.d&&(i=new Buffer(e.d,"base64")),Buffer.isBuffer(e.publicKey)){var f=parsePublicKeyBuffer(t,e.publicKey);n=f.x,s=f.y}else if("string"==typeof e.publicKey){f=parsePublicKeyBuffer(t,new Buffer(e.publicKey,"base64"));n=f.x,s=f.y}else Buffer.isBuffer(e.x)?n=e.x:"string"==typeof e.x&&(n=new Buffer(e.x,"base64")),Buffer.isBuffer(e.y)?s=e.y:"string"==typeof e.y&&(s=new Buffer(e.y,"base64"))}if(!t)throw new TypeError("EC Key curve not specified");if(!n||!s)throw new TypeError("Public EC Key point unavailable");var o=lengths[t];if(!o)throw new TypeError('EC Key curve "'+t+'" invalid');if(n.length!=o)throw new TypeError("Public EC Key point X of wrong length");if(s.length!=o)throw new TypeError("Public EC Key point Y of wrong length");if(i&&s.length!=o)throw new TypeError("Private EC Key of wrong length");Object.defineProperties(this,{curve:{enumerable:!0,configurable:!1,value:t},isPrivateECKey:{enumerable:!0,configurable:!1,value:null!=i},x:{enumerable:!0,configurable:!1,get:function(){return new Buffer(n)}},y:{enumerable:!0,configurable:!1,get:function(){return new Buffer(s)}},jsonCurve:{enumerable:!1,configurable:!1,value:jwkCurves[t]},publicCodePoint:{enumerable:!1,configurable:!1,get:function(){return Buffer.concat([new Buffer([4]),n,s])}}}),i&&Object.defineProperty(this,"d",{enumerable:!0,configurable:!1,get:function(){return new Buffer(i)}})}ECKey.prototype.asPublicECKey=function(){return this.isPrivateECKey?new ECKey({curve:this.curve,x:this.x,y:this.y}):this},ECKey.prototype.toBuffer=function(e){if(e||(e="pem"),"pem"==e)return new Buffer(this.toString("pem"),"ascii");if(this.isPrivateECKey){for(var r=this.d;0==r[0];)r=r.slice(1);if("pkcs8"==e||"rfc5208"==e)return ASN1ECPkcs8Key.encode({version:0,algorithmIdentifier:{privateKeyType:"EC",parameters:this.curve},privateKey:ASN1ECRfc5915Key.encode({version:1,privateKey:r,publicKey:{data:this.publicCodePoint}},"der")},"der");if("rfc5915"==e)return ASN1ECRfc5915Key.encode({version:1,privateKey:r,parameters:this.curve,publicKey:{data:this.publicCodePoint}},"der");throw new TypeError('Unknown format for private key "'+e+'"')}if("spki"==e||"rfc5280"==e)return ASN1ECSpkiKey.encode({algorithmIdentifier:{publicKeyType:"EC",parameters:this.curve},publicKey:{data:this.publicCodePoint}},"der");throw new TypeError('Unknown format for public key "'+e+'"')},ECKey.prototype.toString=function(e){if(e||(e="pem"),this.isPrivateECKey){if("pem"==e)return"-----BEGIN PRIVATE KEY-----\n"+this.toBuffer("pkcs8").toString("base64").match(/.{1,64}/g).join("\n")+"\n-----END PRIVATE KEY-----\n";if("rfc5915"==e)return"-----BEGIN EC PRIVATE KEY-----\n"+this.toBuffer("rfc5915").toString("base64").match(/.{1,64}/g).join("\n")+"\n-----END EC PRIVATE KEY-----\n";if("pkcs8"==e||"rfc5208"==e)return this.toBuffer("pkcs8").toString("base64");if("spki"==e||"rfc5280"==e)return this.toBuffer("spki").toString("base64");throw new TypeError('Unknown format for private key "'+e+'"')}if("pem"==e)return"-----BEGIN PUBLIC KEY-----\n"+this.toBuffer("spki").toString("base64").match(/.{1,64}/g).join("\n")+"\n-----END PUBLIC KEY-----\n";if("spki"==e||"rfc5280"==e)return this.toBuffer("spki").toString("base64");throw new TypeError('Unknown format for public key "'+e+'"')},ECKey.prototype.toJSON=function(){function e(e){return e.toString("base64").replace(/\+/g,"-").replace(/\//g,"_").replace(/=/g,"")}var r={kty:"EC",crv:jwkCurves[this.curve],x:e(this.x),y:e(this.y)},t=this.d;if(t){var i=lengths[this.curve];if(t.length<i){var n=i-t.length;t=Buffer.concat([new Buffer(n).fill(0),t])}r.d=e(t)}return r},exports=module.exports=ECKey;